{
This Program is using a yaw compensated complimentary filter.
It calculates the Pitch and Roll angles.
It uses a 6DOF board from sparkfun which has an ADXL345 ACC and an ITG3200 GYRO.
This section of code determines the I2C lines "IMU.Start(4,5)".
Jason Dories 9DOF obj is used to read the 6DOF Board, which speeds things up greatly.
The current code runs at 200Hz, it is not optimized.
Its purpose was purely to see if I could get the equations to work.
I am using this exact code in my current quadcopter and initial tests look good.  I have only had
time to try hovering with the code but even hovering functions better than without the compensation.
7/1/2013
http://scolton.blogspot.com/2012/09/fun-with-complementary-filter-multiwii.html
The above link is the site I got the equations from.
}
CON
  _clkmode = xtal1 + pll16x                                               
  _xinfreq = 5_000_000

  OTHOU = 1000.0 
  dT    = 0.005
  GLSB  = 14.375
  INV_RAD = 0.017453
  AA = 0.001
VAR

  Long Cog                        

  Long aXraw,aYraw,aZraw
  Long aX,aY,aZ
  
  Long gX,gY,gZ
  
  Long DisplayStack[50]

  Long LastTime
  
  Long error_pitch,error_roll

  Long Gyro_Roll,Gyro_Pitch,Gyro_Yaw
  Long Int_Roll,Int_Pitch                               'Intergrated Gyro Angle
  Long Angle_Roll,Angle_Pitch                           'Final Angle from Comp Filter
  Long Accel_Roll,Accel_Pitch                           'Acc Angle

  Long Status 
OBJ
 
  IMU      : "9DOF-PASM"                                'By Jason Dorie.
  PST      : "Parallax Serial Terminal"                 'By Jeff Martin, Andy Lindsay, Chip Gracey.
  F32      : "F32"                                      'By Jonathan "lonesock" Dummer
  FS       : "FloatString"                              'By Chip Gracey

Pub Main

  F32.start                     'Starts F32 Mathe Engine.                                         
  PST.Start(115_200)            'Starts Parallax Serial Terminal.
  IMU.Start(4,5)                'Starts 9DOF Board                      
  waitcnt(clkfreq*3 + cnt)      'Pause 3 Seconds for initialization.  
  Status := Cog := cognew(Display, @DisplayStack[0])    'Starts Pub Display in a new Cog.
  
  LastTime := cnt
  
  Repeat
    'Go fetch gyro and acc data
    gX    := IMU.GetRX 
    gY    := IMU.GetRY 
    gZ    := IMU.GetRZ 
 
    aXraw := IMU.GetAX -25
    aYraw := IMU.GetAY -8
    aZraw := IMU.GetAZ -17

    'int_pitch = angle_pitch + gyro_pitch * DT
    Gyro_Pitch := F32.FDiv(F32.FFloat(gX),GLSB)
    Int_Pitch := F32.FAdd(Angle_Pitch, F32.FMul(Gyro_Pitch, dT))

    'int_roll = angle_roll + gyro_roll * DT
    Gyro_Roll := F32.FDiv(F32.FFloat(gY),GLSB)
    Int_Roll := F32.FAdd(Angle_Roll, F32.FMul(Gyro_Roll, dT)) 

    Gyro_Yaw := F32.FDiv(F32.FFloat(gZ),GLSB)

  
    'Low Pass Filter for ACC  
  
    aX  := ((aX * 900) + (aXRaw * 100))/1000
  
    aY  := ((aY * 900) + (aYRaw * 100))/1000

    aZ  := ((aZ * 900) + (aZRaw * 100))/1000
    'Converts ACC vectors into Degrees
    Accel_Pitch := F32.Degrees(F32.ATan2(F32.FFloat(aX),F32.FFloat(aZ)))
  
    Accel_Roll  := F32.Degrees(F32.ATan2(F32.FFloat(aY),F32.FFloat(aZ))) 

    'int_pitch += angle_roll * INV_RAD * gyro_yaw * DT
    Int_Pitch := F32.FAdd(Int_Pitch,F32.FMul(F32.FMul(Accel_Roll, INV_RAD), F32.FMul(Gyro_Yaw, dT)))                            
 
    'error_pitch = accel_pitch - int_pitch;
    Error_Pitch := F32.FSub(Accel_Pitch, Int_Pitch)

    'angle_pitch = int_pitch + AA * error_pitch;
    Angle_Pitch := F32.FAdd(Int_Pitch,F32.FMul(AA, Error_Pitch))

    'int_roll -= angle_pitch * INV_RAD * gyro_yaw * DT
    Int_Roll := F32.FSub(Int_Roll,F32.FMul(F32.FMul(Accel_Pitch, INV_RAD), F32.FMul(Gyro_Yaw, dT)))                            
 
    'error_roll = accel_roll - int_roll
    Error_Roll := F32.FSub(Accel_Roll, Int_Roll)

    'angle_roll = int_roll + AA * error_roll
    Angle_Roll := F32.FAdd(Int_Roll,F32.FMul(AA, Error_Roll))    
    
    waitcnt( constant(80_000_000 / 200) + LastTime )    'These 2 lines determine the loop dT.
    LastTime += constant(80_000_000 / 200) 
'*********************************************
PUB Display

  PST.Clear

  Repeat
    PST.Clear

    PST.Str(String("INT Pitch = "))
    PST.Str(fs.FloatToString( Int_Pitch))
    PST.NewLine

    PST.Str(String("INT Roll = "))
    PST.Str(fs.FloatToString( Int_Roll))
    PST.NewLine

    PST.Str(String("Accel Pitch = "))
    PST.Str(fs.FloatToString( Accel_Pitch))
    PST.NewLine

    PST.Str(String("Accel Roll = "))
    PST.Str(fs.FloatToString( Accel_Roll))
    PST.NewLine

    PST.Str(String("Angle Pitch = "))
    PST.Str(fs.FloatToString( Angle_Pitch))
    PST.NewLine

    PST.Str(String("Angle Roll = "))
    PST.Str(fs.FloatToString( Angle_Roll))
    PST.NewLine

    waitcnt(clkfreq/10 + cnt)
    
  